#ifndef __MY_TUTORIAL_MODULE_H__
#define __MY_TUTORIAL_MODULE_H__

#include <OpenTracker/OpenTracker.h>
#include <OpenTracker/dllinclude.h>
#include <OpenTracker/input/SPLModules.h>
#include <OpenTracker/input/MyTutorialSink.h>
#include <OpenTracker/input/MyTutorialSource.h>

#include <OpenTracker/types/Image.h>

#include <string>

#define MAXIMUM_IMAGE_SIZE          8000 // bytes
#define DEFAULT_PUSH_IMAGE_INTERVAL 1 //(ms)

namespace ot {

class OPENTRACKER_API MyTutorialModule : public Module, public NodeFactory
{
  
 public:
  
  // Constructor and destructor
  MyTutorialModule();
  virtual ~MyTutorialModule();
  
  Node* createNode(const std::string& name,  ot::StringTable& attributes);
  void  pushEvent();
  void  pullEvent() {};
  void  init(StringTable&, ConfigNode *);
  int   isEventGenerator() { return 1; };
  //int   isNodePort()       { return 1; };

  void  setTracker(std::vector<float> pos,std::vector<float> quat);
  void  setImage(Image&, int x, int y);
  inline MyTutorialSink *getSink() { return sink; }

  inline void  setPushImageInterval(int intv)  // in millisecond
  {
    pushImageInterval = intv;
  };
  
 private:
  
  MyTutorialSink*   sink;
  MyTutorialSource* source;
  int               pushImageInterval; // (us)
  
  friend class  MyTutorialSink;
  friend class  MyTutorialSource;
};

OT_MODULE(MyTutorialModule);


} // end of namespace ot

#endif // __MY_TUTORIAL_MODULE_H__
