#ifndef __MY_TUTORIAL_SINK_H__
#define __MY_TUTORIAL_SINK_H__

#include <OpenTracker/OpenTracker.h>

#include <OpenTracker/types/Image.h>

namespace ot {
  
  class MyTutorialSink : public ot::Node
  {
  private:
    std::vector<float> position;
    std::vector<float> orientation;

    // This node has two bufferes for received data.
    Image* image;
    Image* image_buf;
    int    width;
    int    height;
    int    width_buf;
    int    height_buf;
    double timestamp;

  public:
    
    MyTutorialSink();
    ~MyTutorialSink();
    
  public:
    
    virtual int isEventGenerator() {return 1;};
    virtual void onEventGenerated(Event&, Node&);

    inline void getTracker(std::vector<float>& pos, std::vector<float>& ori)
    {
      pos = position;
      ori = orientation;
    }

    inline void getImage(Image& im, int& w, int& h)
    {
      if (image)
        {
          im = *image;
        }
      w  = width;
      h  = height;
    }

    inline double getTimestamp() {return timestamp;}
    
  };

} // end of namespace ot

#endif // end of __MY_TUTORIAL_SINK_H
